/***** new2view.c *********************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Fri Sep 21 15:15:59 2012
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "interface.h"
#include "eprintf.h"
#include "tree.h"

void scanFile(FILE *fp, Args *args, int i);

int main(int argc, char *argv[]){
  int i;
  char *version;
  Args *args;
  FILE *fp;

  version = "0.13";
  setprogname2("new2view");
  args = getArgs(argc, argv);
  if(args->v)
    printSplash(version);
  if(args->h || args->e)
    printUsage(version);
  if(args->numInputFiles == 0){
    fp = stdin;
    scanFile(fp, args, 0);
  }else{
    for(i=0;i<args->numInputFiles;i++){
      fp = efopen(args->inputFiles[i],"r");
      scanFile(fp, args, i);
      fclose(fp);
    }
  }
  free(args);
  free(progname());
  return 0;
}

void scanFile(FILE *fp, Args *args, int i){
  Node *root;

  setBisonFile(fp);
  while((root = parseTree()) != NULL){
    root->x = root->y = 0; /* avoid valgrind warning if > 1 tree analyzed */
    if(deg(root) == 2 && !args->u){
      args->r = 1;
      layoutRootedTree(root);
    }else if(deg(root) == 3 && !args->r){
      args->u = 1;
      layoutUnrootedTree(root);
    }else if(args->r){
      layoutRootedTree(root);
    }else if(args->u){
      layoutUnrootedTree(root);
    }else{
      args->r = 1;
      layoutRootedTree(root);
    }
    printLatex(root,args);
  }
}
